/*
 * Decompiled with CFR 0.152.
 */
package fire.pb.main;

import fire.pb.main.DAG;
import java.util.ArrayList;

public class DAGNode<T extends Comparable<T>>
implements Comparable<DAGNode<T>> {
    private final T name;
    private final ArrayList<DAGNode<T>> prevs;
    private final ArrayList<DAGNode<T>> nexts;
    private final DAG<T> dag;

    public ArrayList<DAGNode<T>> getPrevs() {
        return this.prevs;
    }

    public ArrayList<DAGNode<T>> getNexts() {
        return this.nexts;
    }

    public T getName() {
        return this.name;
    }

    DAGNode(T name, DAG<T> dag) {
        this.name = name;
        this.prevs = new ArrayList();
        this.nexts = new ArrayList();
        this.dag = dag;
    }

    public DAGNode<T> addPrev(T name) {
        DAGNode<T> p = this.dag.createNodeIfNotExist(name);
        this.prevs.add(p);
        p.nexts.add(this);
        return this;
    }

    @Override
    public int compareTo(DAGNode<T> o) {
        return this.name.compareTo(o.name);
    }

    public int hashCode() {
        return this.name.hashCode();
    }
}

